//======================================================================
// Header file
//
// Written for the book Programming Windows CE
// Copyright (C) 1998 Douglas Boling
//======================================================================
// Returns number of elements
#define dim(x) (sizeof(x) / sizeof(x[0]))

//----------------------------------------------------------------------
// Generic defines and data types
//
struct decodeUINT {                            // Structure associates
    UINT Code;                                 // messages
                                               // with a function.
    LRESULT (*Fxn)(HWND, UINT, WPARAM, LPARAM);
};
struct decodeCMD {                             // Structure associates
    UINT Code;                                 // menu IDs with a
    LRESULT (*Fxn)(HWND, WORD, HWND, WORD);    // function.
};

//----------------------------------------------------------------------
// Generic defines used by application

#define  ID_ICON             1

#define  IDD_INTEXT          10                // Control IDs
#define  IDD_GETFILE         11
#define  IDD_OUTTEXT         12

// Error codes used by transfer protocol
#define GOOD_XFER        0
#define BAD_FILEOPEN     -1
#define BAD_FILEMEM      -2
#define BAD_FILEREAD     -3
#define BAD_FILEWRITE    -3
#define BAD_SOCKET       -4
#define BAD_SOCKETRECV   -5
#define BAD_FILESIZE     -6
#define BAD_MEMORY       -7

#define BLKSIZE          2048                   // Transfer block size

//----------------------------------------------------------------------
// Function prototypes
//
int ServerThread (PVOID pArg);
int SenderThread (PVOID pArg);
int GetFile (HWND hWnd, TCHAR *szFileName);

int InitApp (HINSTANCE);
HWND InitInstance (HINSTANCE, LPWSTR, int);
int TermInstance (HINSTANCE, int);

// Window procedures
LRESULT CALLBACK MainWndProc (HWND, UINT, WPARAM, LPARAM);

// Message handlers
LRESULT DoCommandMain (HWND, UINT, WPARAM, LPARAM);
LRESULT DoDestroyMain (HWND, UINT, WPARAM, LPARAM);

// Command functions
LPARAM DoMainCommandGet (HWND, WORD, HWND, WORD);
LPARAM DoMainCommandExit (HWND, WORD, HWND, WORD);

// Thread functions
int SenderThread (PVOID pArg);
int ReaderThread (PVOID pArg);
