//======================================================================
// Header file
//
// Written for the book Programming Windows CE
// Copyright (C) 1998 Douglas Boling
//======================================================================
// Returns number of elements
#define dim(x) (sizeof(x) / sizeof(x[0])) 

//----------------------------------------------------------------------
// Generic defines and data types
//
struct decodeUINT {                            // Structure associates
    UINT Code;                                 // messages 
                                               // with a function.
    LRESULT (*Fxn)(HWND, UINT, WPARAM, LPARAM);
}; 
struct decodeCMD {                             // Structure associates
    UINT Code;                                 // menu IDs with a 
    LRESULT (*Fxn)(HWND, WORD, HWND, WORD);    // function.
};

//----------------------------------------------------------------------
// Generic defines used by application

#define  ID_ICON             1   
#define  IDC_RPTLIST         10                // Control IDs

//----------------------------------------------------------------------
// Function prototypes
//
int InitApp (HINSTANCE);
HWND InitInstance (HINSTANCE, LPSTR, int);
int TermInstance (HINSTANCE, int);
void Add2List (HWND hWnd, LPTSTR lpszFormat, ...);

// Window procedures
LRESULT CALLBACK MainWndProc (HWND, UINT, WPARAM, LPARAM);

//**********************************************************************
// MyDccSink
//
class MyDccSink : public IDccManSink {
public:
    MyDccSink (HWND hWnd, IDccMan *pDccMan);
    ~MyDccSink ();

    // *** IUnknown methods ***
    STDMETHODIMP QueryInterface (THIS_ REFIID riid, LPVOID * ppvObj);
    // Note: No reference counting is actually maintained on this object
    STDMETHODIMP_(ULONG) AddRef (THIS);
    STDMETHODIMP_(ULONG) Release (THIS);

    // These methods correspond to GW_LOG messages generated by the Win95
    //  DccMan application. (On NT, the GW_LOG messages are simulated.)
    STDMETHODIMP OnLogIpAddr (THIS_ DWORD dwIpAddr);
    STDMETHODIMP OnLogTerminated (THIS);
    STDMETHODIMP OnLogActive (THIS);
    STDMETHODIMP OnLogInactive (THIS);
    STDMETHODIMP OnLogAnswered (THIS);
    STDMETHODIMP OnLogListen (THIS);
    STDMETHODIMP OnLogDisconnection (THIS);
    STDMETHODIMP OnLogError (THIS);

private:
    long m_lRef;
    HWND hWnd;
    IDccMan *m_pDccMan;
};
