//======================================================================
// Header file
//
// Written for the book Programming Windows CE
// Copyright (C) 1998 Douglas Boling
//======================================================================

// Returns number of elements
#define dim(x) (sizeof(x) / sizeof(x[0]))

// **** Start of Generic COM declarations ****

//======================================================================
// MyClassFactory - Object declaration
//
class MyClassFactory : public IClassFactory {

private:
    long m_lRef;

public:
    MyClassFactory();
    ~MyClassFactory();

    // IUnknown methods
    STDMETHODIMP QueryInterface (THIS_ REFIID riid, LPVOID *ppv);
    STDMETHODIMP_(ULONG) AddRef (THIS);
    STDMETHODIMP_(ULONG) Release (THIS);

    // IClassFactory methods
    STDMETHODIMP CreateInstance (LPUNKNOWN pUnkOuter, REFIID riid,
                                 LPVOID *ppv);
    STDMETHODIMP LockServer (BOOL fLock);
};

// **** End of Generic OLE declarations ****

//----------------------------------------------------------------------
// Defines used by the DLL
//
#define BUFFSIZE        4096

#define FILESIZELIMIT   (100*1024)
#define FILEBREAKSIZE   (100*1024)

//======================================================================
// MyFileFilter - Object declaration
//
class MyFileFilter : public ICeFileFilter {

private:
    long m_lRef;
    BOOL m_fBreakFile;
    ULONG m_ulTotalMoved;

public:
    MyFileFilter();
    ~MyFileFilter();

    // IUnknown methods
    STDMETHODIMP QueryInterface (THIS_ REFIID riid, LPVOID *ppvObj);
    STDMETHODIMP_(ULONG) AddRef (THIS);
    STDMETHODIMP_(ULONG) Release (THIS);

    // ICeFileFilter methods
    STDMETHODIMP NextConvertFile (THIS_ int nConversion,
                        PFF_CONVERTINFO *pci, PFF_SOURCEFILE *psf,
                        PFF_DESTINATIONFILE *pdf,
                        volatile BOOL *pbCancel, PF_ERROR *perr);
    STDMETHODIMP FilterOptions (THIS_ HWND hwndParent);
    STDMETHODIMP FormatMessage (THIS_ DWORD dwFlags, DWORD dwMessageId,
                              DWORD dwLanguageId, LPTSTR lpBuffer,
                              DWORD dwSize, va_list *args, DWORD *pcb);
};
