.386
locals
jumps
.model flat,STDCALL
include win32t.inc

extrn   ExitProcess:PROC
extrn   GetModuleHandleA:PROC
extrn   GetProcAddress:proc
extrn   LoadLibraryA:proc
extrn   FreeLibrary:proc
extrn   MessageBoxA:PROC

.data

HWnd         	dd      0
ModName         db      'GHIRIRSA.DLL',0
ModHandle       dd      0
ProcRSA         db      'ghRSAexp',0			; int ghRSAexp(char * lpe, char * lpn, int base, char * lpm, char * output)
ghRSAexp	dd	0
ConTitle        db      'Attention!',0
ErrMsg          db      'Something went wrong...',0
EncryptTitle	db	'String to be encrypted',0
EncryptedTitle	db	'String encrypted',0
DecryptedTitle	db	'String decrypted',0
StringMsg	db	'1234567890',0
bign		db	'846376620031729071316849',0	; n=p*q
bigp		db	'878048851763',0		; p (not used)
bigq		db	'963928850123',0		; q (not used)
bigd		db	'835166846830229770312741',0	; d decryption modulus (calculated using my CE.EXE program)
bige		db	'65537',0			; e encryption modulus (i chose this cos i knew it was prime)
Buffer		db	100 dup (0)			; big buffer (a little wasteful for our purposes ;)

.code
start:
        call    GetModuleHandleA,0
        mov     [HWnd],eax

	; load GHIRIRSA.DLL library
        call    LoadLibraryA, OFFSET ModName
        test    eax,eax
        jz      error
        mov     ModHandle,eax

	; get address of ghRSAexp function
        call    GetProcAddress, eax, offset ProcRSA	
        test    eax,eax
        jz      error
        mov	ghRSAexp,eax

	; display message before encryption
        Call    MessageBoxA,0,offset StringMsg,offset EncryptTitle,MB_OK

	; encrypt
	push	offset Buffer		; output buffer (make sure this is big enough)
	push	offset StringMsg	; message to be encrypted
	push	10			; base of input and output (e.g. this example uses base 10, you can use hexadecimal too or other bases up to 255 - note base 256 is not supported due to extra problems created by lack of a terminating character)
	push	offset bign		; n (modulus we reduce by)
	push	offset bige		; e (encryption exponent)
	call	ghRSAexp

	; display message after encryption
        Call    MessageBoxA,0,offset Buffer,offset EncryptedTitle,MB_OK        

	; decrypt - note: uses same function as for encryption except we use the decryption exponent
	call	ghRSAexp,offset bigd,offset bign,10,offset Buffer,offset Buffer

	; display message after decryption
        Call    MessageBoxA,0,offset Buffer,offset DecryptedTitle,MB_OK

        mov     eax,ModHandle
        call    FreeLibrary,eax
        
        jmp	exit
error:
        Call    MessageBoxA,0,offset ErrMsg,offset ConTitle,MB_OK
exit:
	call    ExitProcess,0
end start